Subject: Re: UDP is bypassing qdisc statistics ....

From: Eric Dumazet <[email-masked]>
Date: Tue, 01 Sep 2009 09:00:46 +0200

Jarek Poplawski a écrit :
> On 31-08-2009 22:58, Mark Smith wrote:
>> On Mon, 31 Aug 2009 21:54:49 +0200
>> Eric Dumazet <[email-masked]> wrote:
>>
>>> Christoph Lameter a écrit :
>>>> This is with 2.6.31-rc7. If I send icmp then its correctly registered as a
>>>> packet by the qdisc layer:
>>>>
>> <snip>
>>> loopback device do bypass qdisc layer for example...
>> On occassion, I'd have found it useful if it didn't. It'd be convenient
>> to test out your qdisc config, or test out applications performance
>> behaviour over a simulated WAN via netem, without having to a
>> network and two hosts, and all the related miscellaneous setup work.
> 
> Probably Eric and you mean something special, but generally a loopback
> and some other virtuals bypass qdisc layer only with default qdisc.
> 

Yes, I was referring to Christoph use, since on its machine, only
output from "tc -s -d qdisc" is about eth0

Mark, you can certainly do something like

# tc qdisc del dev lo root
# tc qdisc add dev lo root netem delay 100ms 10ms

# ping 127.0.0.1
PING 127.0.0.1 (127.0.0.1) 56(84) bytes of data.
2009/08/01 08:59:22.799 64 bytes from 127.0.0.1: icmp_seq=1 ttl=64 time=204 ms
2009/08/01 08:59:23.804 64 bytes from 127.0.0.1: icmp_seq=2 ttl=64 time=208 ms
2009/08/01 08:59:24.801 64 bytes from 127.0.0.1: icmp_seq=3 ttl=64 time=204 ms
2009/08/01 08:59:25.808 64 bytes from 127.0.0.1: icmp_seq=4 ttl=64 time=209 ms

# tc -s -d qdisc show dev lo
qdisc netem 8001: root limit 1000 delay 100.0ms  10.0ms
 Sent 1764 bytes 18 pkt (dropped 0, overlimits 0 requeues 0)
 rate 0bit 0pps backlog 0b 0p requeues 0